/* MyTracksData */

#import <Cocoa/Cocoa.h>

@class MyAddPanelFooter, SBElementArray, iTunesApplication;

@interface MyTracksData : NSTableView <NSTableViewDelegate,NSTableViewDataSource>
{	
	//NSMutableArray *namesArray;
	//NSMutableArray *rolesArray;
	
	NSArrayController *creditsArrayController;
	MyAddPanelFooter *addPanelFooter;
	NSArray *attributesKeys;
//	NSColor *sStripeColor;

	BOOL isVisible;
	//BOOL addCopies;
	NSMutableArray *itunesTracks;
    
    SBElementArray *iTunesEntireLibrary;
    iTunesApplication *iTunes;
}

@property (retain, nonatomic) SBElementArray *iTunesEntireLibrary;
@property (retain, nonatomic) iTunesApplication *iTunes;


//- (NSMutableArray *)namesArray;
//- (NSMutableArray *)roles;

- (void)mySetup;


- (IBAction)deleteSelected:(id)sender;
- (IBAction)addNewRow:(id)sender;

- (void)deselectTable;
//- (void)clearAll;
- (void)setEntry:(MOEntry *)anEntry;
- (void)updateEntry:(MOEntry *)anEntry;
- (BOOL)setFromDictionary:(NSDictionary *)aDictionary;
- (void)fillDictionary:(NSMutableDictionary *)aMutableDictionary;


//- (void)addCreditsTo:(NSManagedObject *)anEntry;
//- (void)setCreditsFrom:(NSManagedObject *)anEntry;


// itunes inttegration
- (void)setiTunesTracksAlbumStatusForEntry:(NSManagedObject *)anEntry checkiTunes:(BOOL)iTunesIsRunning;
- (void)setDurationCD:(NSMutableArray *)duration;

- (IBAction)loadItunes:(id)sender;
- (void)applicationTerminating;
- (IBAction)playSong:(id)sender;
- (void)calculateTotalDuration;

- (IBAction)addArtistColumn:(id)sender;

- (IBAction)addComposerColumn:(id)sender;
- (BOOL)hasComposer;	

//- (NSArray *)itunesTracks;
- (BOOL)hasArtist;

- (BOOL)isTrackInItunes:(id)aTrackInfo mainEntry:(id)anEntryInfo;
- (void)playSongWithName:(NSString *)name artist:(NSString *)artist;

@end
