//
//  MyBezelDisplay.h
//  CDpedia
//
//  Created by Conor Dearden on 1/7/05.
//  Copyright 2005 Chiguire LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface MyBezelDisplay : NSView {
	NSString *displayString;
	NSColor *textColor;
	
	float textHeight;
}

+ (MyBezelDisplay *)initWithString:(NSString *)aString color:(NSColor *)aColor;
+ (void)displayString:(NSString *)aString forSeconds:(float)someSeconds color:(NSColor *)aColor;

- (void)setDisplayString:(NSString *)aString color:(NSColor *)aColor;
- (void)showForSeconds:(NSNumber *)aNumberOfSeconds;
@end
