//
//  MyConstants.h
//  Pediabase
//
//  Created by Conor Dearden on 18/1/06.
//  Copyright 2006 Chiguire LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

/*
 #ifndef DEBUG  //Could also add -DDEBUG to build settings
 #define DEBUG 
 #endif
 */
//MacAppStore, BETA defined in build settings

#define A_MONTH_IN_SECONDS 2592000
#define A_WEEK_IN_SECONDS 604800
#define A_DAY_IN_SECONDS 86400

//#define MKOSXLeopard 0x00001050
#define MKOSXLeopard 5
#define MKOSXSnowLeopard 6
#define MKOSXLion 7
#define MKOSXMountainLion 8
#define MKOSXMavericks 9
#define MKOSXYosemite 10
#define MKOSXElCapitan 11
#define MKOSXSierra 12
#define MKOSXHighSierra 13


//#define ROW_STRIPE_COLOR BMakeColorFromRGB(243.0, 246.0, 250.0)  // Pre Yosemite
#define ROW_STRIPE_COLOR BMakeColorFromRGB(245.0, 245.0, 245.0)


#define MKCollectionTypeLibrary [NSNumber numberWithInt:0]
#define MKCollectionTypeBorrowed [NSNumber numberWithInt:10]
#define MKCollectionTypeWishlist [NSNumber numberWithInt:20]
#define MKCollectionTypeGroup [NSNumber numberWithInt:30]
#define MKCollectionTypeSmart [NSNumber numberWithInt:40]
#define MKCollectionTypeNormal [NSNumber numberWithInt:50]
//#define MKCollectionTypeExcluded [NSNumber numberWithInt:55]
#define MKCollectionTypeShared [NSNumber numberWithInt:60]
#define MKCollectionTypeDoghouseNew [NSNumber numberWithInt:70] 
#define MKCollectionTypeDoghouseApprove [NSNumber numberWithInt:80]
#define MKCollectionTypeDoghouseApproveComics [NSNumber numberWithInt:81]
#define MKCollectionTypeDoghouseNoImages [NSNumber numberWithInt:83]
#define MKCollectionTypeDoghouseNoAuthor [NSNumber numberWithInt:84]
#define MKCollectionTypeDoghouseDuplicates [NSNumber numberWithInt:85]
#define MKCollectionTypeDoghouseSpecial [NSNumber numberWithInt:90]
//#define MKCollectionTypeDoghouseUpdate [NSNumber numberWithInt:80]

#define MKPrefKeyDemoPeriod @"NSWindowOrder"
#define MKPrefKeyLaunch @"NSWindowBegin"

/*
#define MKLocationGeneralLeft @"left"
#define MKLocationGeneralRight @"right"
#define MKLocationExtra @"extra"
#define MKLocationThird @"third"
#define MyRatingViewDidChangeNotification @"MyRatingViewDidChangeNotification"

//#define MKLocationMulti @"multi"
//#define MKLocationNone @"none"
 */


#define MKStateFilterSelect [NSNumber numberWithInt:1]
#define MKStateFilter [NSNumber numberWithInt:2]
#define MKStateSelectCollection [NSNumber numberWithInt:3]
#define MKStateSelectMovie [NSNumber numberWithInt:4]
#define MKStateHide [NSNumber numberWithInt:5]
#define MKStateFilterAll [NSNumber numberWithInt:6]
#define MKStateFilterSameAsSelected [NSNumber numberWithInt:7]
#define MKStateFilterSameActors [NSNumber numberWithInt:8]
#define MKStateFilterContains [NSNumber numberWithInt:9]

@interface MyConstants : NSObject {

}

@end

//extern NSColor *const MKRowStripeColor;

extern NSString *const MKLocationGeneralLeft;
extern NSString *const MKLocationGeneralRight;
extern NSString *const MKLocationExtra;
extern NSString *const MKLocationThird;

extern NSString *const MyRatingViewDidChangeNotification;


//STRING CONSTANTS Collection

extern NSString *const MKCollectionType;
extern NSString *const MKCollectionExcluded;
extern NSString *const MKCollectionEntries;
extern NSString *const MKCollectionName;
extern NSString *const MKCollectionURL;


//Toolbar Item Indentifiers
extern NSString *const MKToolbarIdentifierMain;
extern NSString *const MKToolbarItemIdentifierAddNewEntry;
extern NSString *const MKToolbarItemIdentifierAddMultiple;
extern NSString *const MKToolbarItemIdentifierShowDetails;
extern NSString *const MKToolbarItemIdentifierEditEntry;
extern NSString *const MKToolbarItemIdentifierRemoveEntry;
extern NSString *const MKToolbarItemIdentifierSearchField;
extern NSString *const MKToolbarItemIdentifierOpenLinks;
extern NSString *const MKToolbarItemIdentifierOpenAmazon;
extern NSString *const MKToolbarItemIdentifierBuyAtAmazon;
extern NSString *const MKToolbarItemIdentifierSellAtAmazon;
extern NSString *const MKToolbarItemIdentifierViewOptions;
extern NSString *const MKToolbarItemIdentifierBorrowEntry;
extern NSString *const MKToolbarItemIdentifierExport;
//extern NSString *const MKToolbarItemIdentifierIpodExport;
extern NSString *const MKToolbarItemIdentifierStatistics;
extern NSString *const MKToolbarItemIdentifierBorrowedHistory;
extern NSString *const MKToolbarItemIdentifierPrint;
extern NSString *const MKToolbarItemIdentifierFullscreen;
extern NSString *const MKToolbarItemIdentifierLastUsedHistory;

// ### Can move to inside of each program toolbar
extern NSString *const MKToolbarItemIdentifierPlayMovie;
extern NSString *const MKToolbarItemIdentifierOpenURL;
extern NSString *const MKToolbarItemIdentifierScanDisc;
extern NSString *const MKToolbarItemIdentifierEjectCD;
extern NSString *const MKToolbarItemIdentifierOpenBarnesAndNobles;
extern NSString *const MKToolbarItemIdentifierOpenScanDisc;

extern NSString *const CFBundleShortVersionString;


//NUMBER CONSTANTS

enum  {
	MKColumnTypeDate = 1,
	MKColumnTypeImage,
	MKColumnTypeMyRating,
	MKColumnTypeCheckBox,
	MKColumnTypeNumber,
	MKColumnTypeUnknown,
	MKColumnTypeString,
	MKColumnTypeInteger
};
typedef NSUInteger MKColumnType;


enum  {
	MKFieldTextField = 1,
	MKFieldTextView = 2,
	MKFieldComboBox = 3,
	MKFieldCheckBox = 4,
	MKFieldDateField = 5,
	MKFieldPopUp = 6,
	MKFieldBorrowedBy = 7,
	MKFieldMyRating = 8,
	MKFieldBuyerName = 9,
	MKFieldBuyerEmail = 10,
	MKFieldTokenField = 11,
	MKFieldNumberField = 12
};
typedef NSUInteger MKField;


// MENU ITEM TAGS
enum  {
	
	MKMenuTagDelete = 10,
	MKMenuTagSelectAll = 11,
	
	// MyCollection
	MKMenuTagNewFromSelection = 12,
	MKMenuTagNewSmart = 13,
	MKMenuTagEditSmart = 14,
	MKMenuTagAddBorrowed = 15,
	MKMenuTagAddWishlist = 16,
	MKMenuTagExclude = 17,
	MKMenuTagNewSpecial = 18,
	MKMenuTagNewWithSelection = 19,
	MKMenuTagShowCountColumn = 70,
	MKMenuTagNewUpdateShared = 71,

	
	// Controller
	MKMenuTagMainTableHasSelection = 12, //MyDoghouse also
	MKMenuTagMainTableHasOneSelection = 13, //edit advance info
	MKMenuTagMainTableHasEntries = 15,
	//MKMenuTagEntryCanBeLinkedToAmazon = 16,
    MKMenuTagEntryHasURL = 16,
	MKMenuTagEntryHasLinks = 17,
	//MKMenuTagEntryHasIMDBNumber = 18,
	MKMenuTagEntryHasISBN = 19,
	MKMenuTagShowDuplicates = 20,

	MKMenuTagMarkAsToday = 30,
	MKMenuTagMarkAsYesterday = 31,
	MKMenuTagMarkAsLastWeek = 32,
	MKMenuTagMarkAsLastMonth = 33,	
	
	MKMenuTagMarkAsBorrowed = 34,
	MKMenuTagMarkAsWishlist = 35, 
	MKMenuTagMarkAsRemoveStatus = 36, 
	MKMenuTagMarkAsSigned = 37,
	MKMenuTagMarkAsSold = 38,
	MKMenuTagMarkAsBought = 39, 
	

	MKMenuTagSpotlight = 40,
	MKMenuTagWidget = 41,
	MKMenuTagBluetooth = 42,
	MKMenuTagGearButtonSearch = 43,
	MKMenuTagRegistration = 60,
		
	// MyAddressBook
	MKMenuTagEmailBorrower = 31, 

	// MyToolbar
	MKMenuTagHideShowToolBar = 80,
	
	// MyTableView 
	MKMenuTagCopyBibliography = 60,
	MKMenuTagCopyLinkAsText = 61,
	MKMenuTagShowInCollection = 62,	
	
	// MyFieldControllerShared
	MKMenuTagSetDefaultWidth = 151,
	
	// MyDoghouse
	MKMenuTagHelp = 107,
	MKMenuTagOnlineMenu = 101,
	MKMenuTagContributeSelection = 102,
	MKMenuTagDoghouseSettings = 103,
	MKMenuTagContributeCollection = 43,
	MKMenuTagHasDogTag = 110,
	MKMenuTagDoghouseApprove = 111,
	MKMenuTagDoghouseMerge = 112,
    MKMenuTagDoghouseDelete = 113,
    MKMenuTagDoghouseMirror = 114,
    MKMenuTagDoghouseCollections = 115,


	// MyInternetSearchPanel
	MKMenuTagSearchLocale = 2,
	
	// MypluginManager
	MKMenuTagSeparator = 500


} ;

//PROGRAM TYPES
enum {
	MKProgramDVDpedia = 1,
	MKProgramBookpedia,
	MKProgramCDpedia,
	MKProgramGamepedia
};
typedef NSInteger MKProgramType;


//ERROR CODES FOR NSERROR
enum  {
	MKEISBN = 1
};

//Export type
enum {
	MKExportTypeHTML = 1,
	MKExportTypeDotMac,
	MKExportTypeiPod,
	MKExportTypeDotPedia,
	MKExportTypeFTP,
	MKExportTypeText,
	MKExportTypeBackup,
	MKExportTypePrinting
};

// Search Types
//!!! Add them to all the searchtypes especially the smart collection to make easier to read
typedef enum {
	MKSearchTypeContains = 0,
	MKSearchTypeDoesNotContain,
	MKSearchTypeIsEqual,
	MKSearchTypeIsNotEqual,
	MKSearchTypeStartsWith,
	MKSearchTypeEndsWith,
	
	MKSearchTypeNumberIs = 10,
	MKSearchTypeNumberIsNot,
	MKSearchTypeNumberIsLessThan,
	MKSearchTypeNumberIsGreaterThan,
	
	MKSearchTypeDateIs = 20,
	MKSearchTypeDateIsNot,
	MKSearchTypeDateIsBefore,
	MKSearchTypeDateIsAfter,
	MKSearchTypeDateInTheLast,
	MKSearchTypeDateInTheNext,
	MKSearchTypeDateAfterTheLast,
	
	MKSearchTypeMyRatingIs = 30,
	MKSearchTypeMyRatingIsNot,
	MKSearchTypeMyRatingIsLessThan,
	MKSearchTypeMyRatingIsGreaterThan,
	
	MKSearchTypeCheckBoxIsSet = 40,
	MKSearchTypeCheckBoxIsNotSet
	
} MKSearchType;


// Top Right Filter Types
typedef enum {
    MKFilterNone = -1,
	MKFilterColumns = 0,
	MKFilterAll = 1,
	MKFilterTitles = 3,
	MKFilterStarring = 4,
	MKFilterAuthors = 4,
	MKFilterArtists = 4,
	MKFilterPlatforms = 4,
	MKFilterLinks = 5,
    MKFilterComposers = 6,
	MKFilterDirectors = 6,
	MKFilterPublishers = 6,
	MKFilterWriters = 7,
	MKFilterSubjects = 7,
	MKFilterComments = 7,
	MKFilterDevelopers = 7,
	MKFilterSummaries = 8,
	MKFilterCredits = 9,
	MKFilterTracks = 9,
	MKFilterGenres = 10,
	MKFilterTags = 11,
	MKFilterTracksOther = 12,
	MKFilterISBNs = 13,
    MKFilterReleaseDate = 40,
    MKFilterTheatrical = 41,
    MKFilterCustomTag1 = 42,
    MKFilterCustomTag2 = 43, 
    MKFilterClickedField = 100,
    MKFilterLastUsedDate
} MKFilter;


#pragma mark -
#pragma mark Distributed Object Automator

@class MOCollection;

@protocol PediabaseDistributedProtocol
- (bycopy NSArray *)findEntriesForAttributes:(bycopy NSDictionary *)searchAttributes;
- (bycopy NSArray *)getSelectedDVDs;
- (bycopy NSArray *)findEntriesInCollection:(bycopy NSString *)searchString searchType:(int)searchType;

- (bycopy NSArray *)getImagePathForEntries:(bycopy NSArray *)entryNumbers;
- (bycopy NSString *)exportEntries:(bycopy NSArray *)entryNumbers name:(bycopy NSString *)exportName sorted:(bycopy NSString *)sortBy descending:(BOOL)sortDescending template:(bycopy NSString *)selectedTemplate separated:(int)typeExport;
- (bycopy NSArray *)getPossibleTemplatesFor:(int)exportType;
- (bycopy NSArray *)importURLs:(bycopy NSArray *)aListOfURL;

- (bycopy NSArray *)getPossibleCollections;
- (void)selectCollectionsWithUID:(NSNumber *)aUID;
- (void)createNewCollectionWithName:(bycopy NSString *)aString entries:(bycopy NSArray *)entryNumbers;
- (void)addEntryNumbersToSelectedCollection:(bycopy NSArray *)entryNumbers;

- (NSString *)convertDVDsToText:(bycopy NSArray *)entryNumbers withTextTemplate:(bycopy NSString *)aString;

@end


#pragma mark - Inline Functions


static inline BOOL hasSpecialLastNameEnding(NSString *name) {
    if ([name hasSuffix:@" Jr."] || [name hasSuffix:@" II"]  || [name hasSuffix:@" III"] || [name hasSuffix:@" IV"] || [name hasSuffix:@" "] || [name hasSuffix:@" M.D."] || [name hasSuffix:@" M.A."] || [name hasSuffix:@" Ph.D."])
        return YES;
    return NO;
}


/*NS_INLINE void MVComputeTimeWithNameAndBlock(const char *caller, void (^block)()) {
    CFTimeInterval startTimeInterval = CACurrentMediaTime();
    block();
    CFTimeInterval nowTimeInterval = CACurrentMediaTime();
    MyLog(@"%s - Time Running is: %f", caller, nowTimeInterval - startTimeInterval);
}
#define MVComputeTime(...) MVComputeTimeWithNameAndBlock(__PRETTY_FUNCTION__, (__VA_ARGS__))
 */

static inline NSString* MyPrefOrDefaultStringValueForKey(NSString *key, NSString *table, NSBundle *bundle) {
	NSString *bodyBorrowerEmail = [[NSUserDefaults standardUserDefaults] objectForKey:key];
	if (bodyBorrowerEmail == nil)
		bodyBorrowerEmail = NSLocalizedStringWithDefaultValue(key, table, bundle, nil, nil);
	return bodyBorrowerEmail;
}

static inline NSColor* BMakeColorFromRGB(float red, float green, float blue) {
	return [NSColor colorWithDeviceRed:red/255.0f green:green/255.0f blue:blue/255.0f alpha:1.0f];
}


static inline NSString* removeArticleFromString(NSString *aString) {
	// A faster version than the original below
	NSUInteger length = [aString length];
	if (length) {
		unichar achar = [aString characterAtIndex:0];
		
		if (achar == '\"' && length > 1) {
			aString = [aString substringFromIndex:1];
			achar = [aString characterAtIndex:0];
			length--;
		}
		
		if (achar == 'T' && length > 4 && [aString characterAtIndex:1] == 'h' && [aString characterAtIndex:2] == 'e' && [aString characterAtIndex:3] == ' ')
			aString = [aString substringFromIndex:4];
		else if (achar == 'A') {
			if (length > 3) {
                achar = [aString characterAtIndex:1];
				if (achar == ' ')
					aString = [aString substringFromIndex:2];
				else if (achar == 'n' && [aString characterAtIndex:2] == ' ')
					aString = [aString substringFromIndex:3];
			}
		}
	}
	return aString;
}

/*
static inline NSInteger rangeOfArticleFromString(NSString *aString) {
	// A faster version than the original below
	NSUInteger length = [aString length];
	if (length) {
		unichar achar = [aString characterAtIndex:0];
		
		if (achar == '\"' && length > 1) {
			aString = [aString substringFromIndex:1];
			achar = [aString characterAtIndex:0];
			length--;
		}
		
		if (achar == 'T' && length > 4 && [aString characterAtIndex:1] == 'h' && [aString characterAtIndex:2] == 'e' && [aString characterAtIndex:3] == ' ')
			return 4;
		else if (achar == 'A') {
			if (length > 3) {
                achar = [aString characterAtIndex:1];
				if (achar == ' ')
					return 4;
				else if (achar == 'n' && [aString characterAtIndex:2] == ' ')
					return 3;
			}
		}
	}
	return 0;
}
 */



/*if ([aString hasPrefix:@"\""])
 aString = [aString substringFromIndex:1];
 
 if ([aString hasPrefix:@"The "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"A "])
 return [aString substringFromIndex:2];
 else if ([aString hasPrefix:@"An "])
 return [aString substringFromIndex:3];
 
 return aString;
 */

static inline NSString* lastNameForString(NSString *aString) {

	//Ignore anything past a coma slash or parenthesis
    NSCharacterSet *separatorSet = [NSCharacterSet characterSetWithCharactersInString:@",/("];
	NSArray *parts1 = [aString componentsSeparatedByCharactersInSet:separatorSet];
	
	//Seperate by spaces and use the last word
	NSString *possibleEndingSpace1 = [parts1 objectAtIndex:0];
	if ([parts1 count])
		parts1 = [possibleEndingSpace1 componentsSeparatedByString:@" "];
	
	int part1Count = [parts1 count] - 1;
	if (hasSpecialLastNameEnding(possibleEndingSpace1))
		part1Count--;
	if (part1Count >= 0)
		return [parts1 objectAtIndex:part1Count];
	return nil;
}


static inline NSString* removeForeignArticleFromString(NSString *aString) {
	
	// A faster version than the original below
	NSUInteger length = [aString length];
	if (length) {
		unichar achar = [aString characterAtIndex:0];

		// ", The, A, An, El, Ein, Eine, Einen, Einem, Einer, Eines, Un, Una, Une, Des, Der, Dem, Den, Die, Das, L', Lo, La, Le, Les, Los, Las, Il
		if (achar == '\"' && length > 1) {
			aString = [aString substringFromIndex:1];
			achar = [aString characterAtIndex:0];
			length--;
		}
		
		if (achar == 'T' && length > 4 && [aString characterAtIndex:1] == 'h' && [aString characterAtIndex:2] == 'e' && [aString characterAtIndex:3] == ' ')
			return [aString substringFromIndex:4];
		else if (achar == 'A') {
			if (length > 3) {
				if ([aString characterAtIndex:1] == ' ')
					return [aString substringFromIndex:2];
				else if ([aString characterAtIndex:1] == 'n' && [aString characterAtIndex:2] == ' ')
					return [aString substringFromIndex:3];
			}
		}
		else if (achar == 'E') {
			if (length > 3) {
				if ([aString characterAtIndex:1] == 'l' && [aString characterAtIndex:2] == ' ') // el
					return [aString substringFromIndex:3];
			}
			if (length > 4) {
				if ([aString characterAtIndex:1] == 'i' && [aString characterAtIndex:2] == 'n' && [aString characterAtIndex:3] == ' ') // ein
					return [aString substringFromIndex:4];
			}
			if (length > 5) {
				if ([aString characterAtIndex:1] == 'i' && [aString characterAtIndex:2] == 'n' && [aString characterAtIndex:3] == 'e' && [aString characterAtIndex:4] == ' ') // eine
					return [aString substringFromIndex:5];
			}
			if (length > 6) {
				if ([aString characterAtIndex:1] == 'i' && [aString characterAtIndex:2] == 'n' && [aString characterAtIndex:3] == 'e' && [aString characterAtIndex:5] == ' ') {
					if (([aString characterAtIndex:4] == 'n') // einen
						|| ([aString characterAtIndex:4] == 'm') // einem
						|| ([aString characterAtIndex:4] == 'r') // einer
						|| ([aString characterAtIndex:4] == 's') // eines
						)
						return [aString substringFromIndex:6];
				}
			}
		}
		else if (achar == 'U') {
			if (length > 3) {
				if ([aString characterAtIndex:1] == 'n' && [aString characterAtIndex:2] == ' ') // Un
					return [aString substringFromIndex:3];
			}
			if (length > 4) {
				if ([aString characterAtIndex:1] == 'n' && [aString characterAtIndex:3] == ' ') {
					if (([aString characterAtIndex:2] == 'a') //Una
						|| ([aString characterAtIndex:2] == 'e') // Une
						)
						return [aString substringFromIndex:4];
				}
			}
		}
		else if (achar == 'D') {
			if (length > 4) {
				if ([aString characterAtIndex:1] == 'e' && [aString characterAtIndex:3] == ' ') {
					if (([aString characterAtIndex:2] == 's') // Des
						|| ([aString characterAtIndex:2] == 'r') // Der
						|| ([aString characterAtIndex:2] == 'm') // Dem
						|| ([aString characterAtIndex:2] == 'n') // Den
						)
						return [aString substringFromIndex:4];
				}
				else if (([aString characterAtIndex:1] == 'i' && [aString characterAtIndex:2] == 'e' && [aString characterAtIndex:3] == ' ') // Die
						 || ([aString characterAtIndex:1] == 'a' && [aString characterAtIndex:2] == 's' && [aString characterAtIndex:3] == ' ') // Das
						 )
					return [aString substringFromIndex:4];
			}
		}
		else if (achar == 'L') {
			
			if (length > 3) {
				if ( [aString characterAtIndex:2] == ' ' && 
					([aString characterAtIndex:1] == '\'' // L'
					 || [aString characterAtIndex:1] == 'o' // Lo
					 || [aString characterAtIndex:1] == 'a' // La
					 || [aString characterAtIndex:1] == 'e')) // Le
					return [aString substringFromIndex:3];
				else if ([aString characterAtIndex:1] == '\'') // L' Without space suffix
					return [aString substringFromIndex:2];
			}
			if (length > 4) {
				if ([aString characterAtIndex:2] == 's' && [aString characterAtIndex:3] == ' ') {
					if (([aString characterAtIndex:1] == 'e') // Les
						|| ([aString characterAtIndex:1] == 'o') // Los
						|| ([aString characterAtIndex:1] == 'a' ) // Las
						)
						return [aString substringFromIndex:4];
				}
			}
			
		}
		else if (achar == 'I') {
			if (length > 3) {
				if (([aString characterAtIndex:1] == 'l' && [aString characterAtIndex:2] == ' ') // Il
					)
					return [aString substringFromIndex:3];
                if (([aString characterAtIndex:1] == ' ') // I Ponti de Madison County "I "
					)
					return [aString substringFromIndex:2];

			}
		}
        else if (achar == 'G') {
			if (length > 4) {
				if (([aString characterAtIndex:1] == 'l' && [aString characterAtIndex:2] == 'i'  && [aString characterAtIndex:3] == ' ') // Gli
					)
					return [aString substringFromIndex:4];                
			}
		}
	}
	return aString;
}

/*
 if ([aString hasPrefix:@"\""])
 aString = [aString substringFromIndex:1];
 
 if ([aString hasPrefix:@"The "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"A "])
 return [aString substringFromIndex:2];
 else if ([aString hasPrefix:@"An "])
 return [aString substringFromIndex:3];
 
 
 if ([aString hasPrefix:@"El "])
 return [aString substringFromIndex:3];
 else if ([aString hasPrefix:@"La "])
 return [aString substringFromIndex:3];
 else if ([aString hasPrefix:@"Los "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Las "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Un "])
 return [aString substringFromIndex:3];
 else if ([aString hasPrefix:@"Una "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Le "])
 return [aString substringFromIndex:3];
 else if ([aString hasPrefix:@"Les "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"L' "])
 return [aString substringFromIndex:3];
 else if ([aString hasPrefix:@"L'"])
 return [aString substringFromIndex:2];
 else if ([aString hasPrefix:@"Une "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Des "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Die "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Der "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Den "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Dem "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Das "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Ein "])
 return [aString substringFromIndex:4];
 else if ([aString hasPrefix:@"Eine "])
 return [aString substringFromIndex:5];
 else if ([aString hasPrefix:@"Einen "])
 return [aString substringFromIndex:6];
 else if ([aString hasPrefix:@"Einem "])
 return [aString substringFromIndex:6];
 else if ([aString hasPrefix:@"Einer "])
 return [aString substringFromIndex:6];
 else if ([aString hasPrefix:@"Eines "])
 return [aString substringFromIndex:6];
 
 
 //qutations and others
 //### Possible addition here and sort to ignore qoutes
 
 //	else if ([aString hasPrefix:[NSString stringWithFormat:@"%c", 201]]) // …
 //		return [aString substringFromIndex:1];
 //	else if ([aString hasPrefix:[NSString stringWithFormat:@"%c", 210]])  // " but curly
 //		return [aString substringFromIndex:1];
 
 
 return aString;
 */


#pragma mark -
#pragma mark Entry Keys
extern NSString *const MKIdentifier;

extern NSString *const MKKeyEntryUID;
extern NSString *const MKKeyEntryDogTag;

#define MKKeyEntryImageLocation @"imageLocation"
#define MKKeyEntryImagePreview @"imagePreview"


/*
extern NSString *const MKKeyEntryRating;
extern NSString *const MKKeyEntryASIN;
extern NSString *const MKKeyEntryBorrowedBy;
extern NSString *const MKKeyEntryBorrowedOn;
extern NSString *const MKKeyEntryCollection;
extern NSString *const MKKeyEntryCollectionID;
extern NSString *const MKKeyEntryComments;
extern NSString *const MKKeyEntryCustomFour;
extern NSString *const MKKeyEntryCustomOne;
extern NSString *const MKKeyEntryCustomThree;
extern NSString *const MKKeyEntryCustomTwo;
extern NSString *const MKKeyEntryDateAdded;
extern NSString *const MKKeyEntryDueDate;
extern NSString *const MKKeyEntryGenre;
extern NSString *const MKKeyEntryLocale;
extern NSString *const MKKeyEntryMyRating;
extern NSString *const MKKeyEntryPaid;
extern NSString *const MKKeyEntryPrice;
extern NSString *const MKKeyEntryPurcahsedAt;
extern NSString *const MKKeyEntryPurchasedOn;
extern NSString *const MKKeyEntryReleaseDate;
extern NSString *const MKKeyEntryStatus;
extern NSString *const MKKeyEntrySummary;
extern NSString *const MKKeyEntryTitle;
extern NSString *const MKKeyEntryURL;


//Several
extern NSString *const MKKeyEntryAwards;
extern NSString *const MKKeyEntryDiscs;
extern NSString *const MKKeyEntryDuration;
extern NSString *const MKKeyEntryFeatures;
extern NSString *const MKKeyEntryLocation;
extern NSString *const MKKeyEntryProducer;
extern NSString *const MKKeyEntryPublisher;
extern NSString *const MKKeyEntryRated;
extern NSString *const MKKeyEntryRegion;
extern NSString *const MKKeyEntryUPC;


#pragma mark Entry Relationships
extern NSString *const MKKeyEntryCollections;
extern NSString *const MKKeyEntryLentHistory;
extern NSString *const MKKeyEntryLinks;


#pragma mark DVD
extern NSString *const MKKeyDVDAspectRatio;
extern NSString *const MKKeyDVDCountry;
extern NSString *const MKKeyDVDDirector;
extern NSString *const MKKeyDVDIMDB;
extern NSString *const MKKeyDVDLanguage;
extern NSString *const MKKeyDVDLastSeen;
extern NSString *const MKKeyDVDMedia;
extern NSString *const MKKeyDVDPictureFormat;
extern NSString *const MKKeyDVDSound;
extern NSString *const MKKeyDVDStarring;
extern NSString *const MKKeyDVDStudio;
extern NSString *const MKKeyDVDSubtitles;
extern NSString *const MKKeyDVDTheatrical;
extern NSString *const MKKeyDVDVideoFormat;
extern NSString *const MKKeyDVDWriter;

#pragma mark DVD Relationships
extern NSString *const MKKeyEntryCredits;


#pragma mark Book
extern NSString *const MKKeyBookAskingPrice;
extern NSString *const MKKeyBookAuthor;
extern NSString *const MKKeyBookBuyerAddress;
extern NSString *const MKKeyBookBuyerEmail;
extern NSString *const MKKeyBookBuyerName;
extern NSString *const MKKeyBookChildrenReadingLevel;
extern NSString *const MKKeyBookCondition;
extern NSString *const MKKeyBookDewey;
extern NSString *const MKKeyBookDimensions;
extern NSString *const MKKeyBookEdition;
extern NSString *const MKKeyBookEditor;
extern NSString *const MKKeyBookFormat;
extern NSString *const MKKeyBookGift;
extern NSString *const MKKeyBookIllustrator;
extern NSString *const MKKeyBookISBN;
extern NSString *const MKKeyBookLastRead;
extern NSString *const MKKeyBookLCCN;
extern NSString *const MKKeyBookMarketPrice;
extern NSString *const MKKeyBookNotes;
extern NSString *const MKKeyBookOnSale;
extern NSString *const MKKeyBookPageMark;
extern NSString *const MKKeyBookPages;
extern NSString *const MKKeyBookPlacedForSaleAt;
extern NSString *const MKKeyBookPlacePublished;
extern NSString *const MKKeyBookSeries;
extern NSString *const MKKeyBookSigned;
extern NSString *const MKKeyBookSoldBook;
extern NSString *const MKKeyBookSoldOn;
extern NSString *const MKKeyBookSubjects;
extern NSString *const MKKeyBookTranslator;


#pragma mark CD
extern NSString *const MKKeyCDArrangedBy;
extern NSString *const MKKeyCDArtist;
extern NSString *const MKKeyCDComposer;
extern NSString *const MKKeyCDConductor;
extern NSString *const MKKeyCDDiscID;
extern NSString *const MKKeyCDLabel;
extern NSString *const MKKeyCDMixedBy;


#pragma mark Game
extern NSString *const MKKeyGameAchievements;
extern NSString *const MKKeyGameCompleted;
extern NSString *const MKKeyGameDeveloper;
extern NSString *const MKKeyGameLastPlayed;
extern NSString *const MKKeyGameManual;
extern NSString *const MKKeyGameMulitplayer;
extern NSString *const MKKeyGameNowPlaying;
extern NSString *const MKKeyGameNumberOfPlayers;
extern NSString *const MKKeyGamePlataform;
extern NSString *const MKKeyGamePlayerRating;
extern NSString *const MKKeyGameScore;
extern NSString *const MKKeyGameSeries;
extern NSString *const MKKeyGameSpecialEdition;
extern NSString *const MKKeyGameRequirements;
extern NSString *const MKKeyGameTime;


#pragma mark -
#pragma mark Link
extern NSString *const MKKeyLinkName;
extern NSString *const MKKeyLinkType;
extern NSString *const MKKeyLinkURL;
// A position key as well


#pragma mark Credit
extern NSString *const MKKeyCreditName;
extern NSString *const MKKeyCreditType;
// A position key as well


#pragma mark SimilarProduct
extern NSString *const MKKeyLentEntryName;
extern NSString *const MKKeyLentEntryDate;
extern NSString *const MKKeyLentEntryReturned;


#pragma mark LentEntry
extern NSString *const MKKeySimilarProductTitle;
extern NSString *const MKKeySimilarProductAsin;
// A position key as well


#pragma mark -
#pragma mark Special
extern NSString *const MKKeyPosition;
extern NSString *const MKKeyEntry;


#pragma mark Super Special
extern NSString *const MKKeyEntryImageLocation;

//### Change to Dictionary
//These most both be of equal length as the first canme in Names corresponds to the first role in Roles
extern NSString *const MKKeyDVDArrayNames;
extern NSString *const MKKeyDVDArrayRoles;

//Same as above where they must be of equal length
extern NSString *const MKKeyCDArraySongs;
extern NSString *const MKKeyCDArrayDurations;
extern NSString *const MKKeyCDArrayArtists;
*/



