/* MyLlave */

#import <Cocoa/Cocoa.h>
#define isSerialKeyValid processMo  //Obfuscate the registration function, due to reverse decoding and categories override 
#define isKeyPirated isWindowBlanc
#define isPirateKey displayWind
#define validateMacAppStoreReceipt prepTableView
//#define validateReceiptAtPath tableViewReadyForCovers
#define dictionaryWithAppStoreReceipt tableViewReadyFor
#define testSavedRegistrationKey makeWindowKeyAndOrder
#define testKeyForValidity preparePathForRead

@interface MyLlave : NSObject {
@private
#ifndef MacAppStore
    IBOutlet NSPanel *registrationPanel;
    IBOutlet NSTextField *statusField;
    IBOutlet NSTextField *registrationKey;
	IBOutlet NSProgressIndicator *busyIndicator;
	
	IBOutlet NSButton *storeButton, *integratedButton;
	
	BOOL isPirateKey;
	
	NSString *publisherID, *activationID, *esellerID, *SKURefNumber, *myPrefix, *eselleratePrefix;
	NSString *publisherKey; 
	unsigned int primeNumber;
	NSArray *llavesMalas;
#endif //MacAppStore
}

@property (strong, nonatomic) NSArray *topLevelObjects;

+ (NSString *)macAddressString;
+ (BOOL)validateReceiptFolder;
+ (NSString *)rot:(NSString *)aRot;

#ifdef MacAppStore
+ (void)validateMacAppStoreReceipt;
//static inline BOOL validateReceiptAtPath(NSString * path);
#else

- (void)startSheet;

- (IBAction)okayPressed:(id)sender;
- (IBAction)canceledPressed:(id)sender;

- (NSString *)isSerialKeyValid:(NSString *)keyValue;

- (IBAction)purchaseIntegrated:(id)sender;
- (IBAction)webStore:(id)sender;
- (IBAction)upgradeInfo:(id)sender;

- (void)testSavedRegistrationKey:(id)info;  //real check once a month at startup 
- (NSInteger)testKeyForValidity:(NSString *)keyValue;
- (void)isKeyPirated:(id)aWindow;  //real pirate code check

- (void)showPanelWithDemoLimit;

//set methods
- (void)setPublisherKey:(NSString *)aString;
- (void)setPublisherID:(NSString *)aString;
- (void)setActivationID:(NSString *)aString;
- (void)setEsellerID:(NSString *)aString;
- (void)setSKURefNumber:(NSString *)aString;
- (void)setMyPrefix:(NSString *)aString;
- (void)setEselleratePrefix:(NSString *)aString;
- (void)setPrimeNumber:(int)anInt;
- (void)setLlavesMalas:(NSArray *)anArray;
#endif //MacAppStore

@end
